//  Copyright (C) 05-02-2016 Jasper den Ouden.
//
//  This is free software: you can redistribute it and/or modify
//  it under the terms of the Afrero GNU General Public License as published
//  by the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.

// ==UserScript==
// @name        Commands
// @namespace   Jasper
// @description Commands hub
// @include     *
// @include     file://*
// @version     0.0.3
// @grant       GM_getValue
// @grant       GM_setValue
// @grant       GM_deleteValue
// @grant       GM_listValues
// @grant       GM_registerMenuCommand
// @grant       GM_xmlhttpRequest
// @grant       GM_openInTab
// @grant       GM_setClipboard
// @grant       GM_addStyle
// ==/UserScript==

// - default_value.js
function default_value(name, to) {
    if( !GM_getValue(name) ) {
        GM_setValue(name, to);
    }
}


{
    var h = "";
// - css/userscript/commands.css
h += "tr:focus{border:0.2em solid black;}";
h += "td:focus{border:0.2em solid black;}";

h += "/* Panel itself. */";
h += "#SDmzj9bS6zlWiRoHyaREFQNCommandPanel{";
h += "    border:0.1em solid black;";
h += "    border-radius: 0.3em;";

h += "    position:fixed;";
h += "    top:1em;";
h += "    left:1em;";
h += "    padding:2em;";
h += "    background-color:white;";
h += "    z-index:10000000000000;";
h += "}";
h += "/* Bookmark stuff */";
h += "#SDmzj9bS6zlWiRoHyaREFQNcmd_bm_uri{ width:100% }";
h += "#SDmzj9bS6zlWiRoHyaREFQNcmd_bm_title{ width:100% }";

h += "/* Symbol output */";
h += "#SDmzj9bS6zlWiRoHyaREFQNcmd_sym_output{ font-size:300%; }";

// - css/style.css
h += ":focus{border:0.2em solid black; font-weight:bold}";

h += ".working{color:red;font-weight:bold}";

h += ".minor{color:#666; font-size:70%;}";

h += ".hour_min{font-weight:bold; font-size:70%; font-family:'Lucida Console'}";

h += ".day_change{font-weight:bold}";

h += ".time_month{color:gray ; font-size:80%}";
h += ".time_wday{color:gray ; font-size:80%}";
h += ".time_mday{color:gray ; font-size:80%}";

h += ".tag{font-weight:bold}";

h += "td{padding-bottom:0em}";
h += "tr{padding-bottom:0em}";

h += "/* Going round TRs";
h += " (https://stackoverflow.com/questions/670424/border-around-specific-rows-in-a-tablepage_html)";
h += "TODO listview should get the general style..";
h += "*/";
h += "tr.top td { border-top: 0.2em solid black; }";
h += "tr.bottom td { border-bottom: 0.2em solid black; }";
h += "tr.row td:first-child { border-left: 0.2em solid black; }";
h += "tr.row td:last-child { border-right: 0.2em solid black; }";

h += "blockquote.bm_quote{background-color:#CCC ; margin:0.0em 0.0em 0.1em 2em}";

h += "table{width:90%}";
h += "input{width:60%}";
h += "textarea{width:90%}";

// - css/ListView.css
h += "#sql{width:95%;}";

h += ".tag{ background-color:#DDF; border-radius: 0.6em; border: 0.14em solid #88F;";
h += "      padding:0.1em 0.1em; font-size:80%";
h += "}";

h += ".rawval{text-width:bold}";

h += ".local_version{ font-size:50%; color:gray }";

h += "a.local_version_href{ color:#779 }";

h += ".edit_this{ font-size:50% }";
    GM_addStyle(h);
}

// - js/common.js

ge_prep = "";

function ge(id) {
    return document.getElementById(ge_prep + id) || { no_result:true };
}
function maybe_ge(el) {
    if( typeof(el) == 'string' ){ return ge(el); } else{ return el; }
}

function prepend_child(to_el, add_el) {
    if(to_el.childNodes[0]) {
        to_el.insertBefore(add_el, to_el.childNodes[0]);
    } else {
        to_el.appendChild(add_el);
    }
}

var hide_buttons = false;
function hide_button(name, yes) {
    var el = maybe_ge(name);
    el.hidden   = hide_buttons && yes;
    el.disabled = yes;
}

function in_viewport(el) {
    var height = window.innerHeight;
    var top    = el.offsetBottom;
    var bottom = el.offsetTop;
    return top > 0 ? top <= height : (bottom > 0 && bottom <= height);
}

function textarea_fitting(te, config) {
    var te = maybe_ge(te);
    te.rows = Math.min(Math.max(te.value.split("\n").length, 0),
                       config.max_rows);
    te.cols = config.cols;
}

// Fits the length constantly.
function textarea_update(te, after_keydown, config) {
    var te = maybe_ge(te);
    textarea_fitting(te, config);

    te.onkeydown = function(ev){
        textarea_fitting(te, config);
        if(after_keydown){ after_keydown(ev); }
    }
}

// Travelling through guis.
function go_graph(to, ev, graph) {
    if( typeof(to) == 'function' ) { ev.preventDefault(); to(ev); }
    else if(to) {
        var got = maybe_ge((graph.extra_prep || "") + to);
        if( !got.hidden ){ ev.preventDefault(); got.focus(); }
        else{ follow_graph(graph)({target:got, keyCode:ev.keyCode, shiftKey:true}); }
    }
}

// TODO more configurability with regard to which keys do what.

function follow_graph(graph) {
    return function(ev) {
        var strip_l = (graph.extra_prep ? graph.extra_prep.length : 0) + ge_prep.length;
        var kc = ev.keyCode, cur = graph[ev.target.id.substr(strip_l)];

        if( !ev.ctrlKey ) {   //Always control key, its consistent.
            return;
        } else if( kc == 13 ) {
            if( cur.ed && (!cur.sd || ev.shiftKey) ) { go_graph(cur.d, ev, graph); }
        } else if( kc == 40 ) {
            if( !cur.sd || ev.shiftKey ) { go_graph(cur.d, ev, graph); }
        } else if( kc == 38 ) {
            if( !cur.su || ev.shiftKey ) { go_graph(cur.u, ev, graph); }
        } else if( kc == 37 ) {
            if( !cur.sl || ev.shiftKey ) { go_graph(cur.l, ev, graph); }
        } else if( kc == 39 ) {
            if( !cur.sr || ev.shiftKey ) { go_graph(cur.r, ev, graph); }
        }
    }
}

// Making lines around current list selection in tables.
function focus_table_list(el, out, prep) {
    var prep = prep || "";
    // Find the `TR` level.
    if( el.nodeName != '#comment' ) {
        while(el && el.nodeName != 'TR'){ el = el.parentNode; }
    }
    // Find the comment node representing the "the start of the section."
    var prev = el;
    while( el  && el.nodeName != '#comment' ) {
        prev = el;
        el = el.previousSibling;
    }
    el = prev;  // Iterate, applying the classes.
    var first, last;
    while( el && (el.nodeName != '#comment') ) {
        first = first || (el.nodeName == 'TR' && el);
        last  = (el.nodeName == 'TR' && el) || last;

        el.className = (out ? "" : prep + "row");

        el = el.nextSibling;
    }
    if( !out ) {
        first.className += " " + prep + "top";
        last.className  += " " + prep + "bottom";
    }
}

// NOTE function below works by returning true if need to skip over.

// Basically here because list entries arent handy units.
// (but i kindah want the vertical alignment of tables.)
function list_move(i, name, info, alt_fun, ev) {
    if(name) {
        if(ev && !info.dont_prevent){ ev.preventDefault(); }

        var funs = info[name] || info;
        var cur = ge(info.nameprep + i + "_" + name);

        if( cur.no_result ){
            // TODO instead, skip.
            return (alt_fun || funs.alt_fun || info.alt_fun ||
                    function(){ return true; })();
        } else {
            cur.onfocus = function() {
                cur.hidden = false;
                focus_table_list(cur, false);  // Add the borders.
            }
            cur.onblur = function(){
                cur.hidden = funs.hide_it;
                focus_table_list(cur, true);  // Remove the borders.
            }
            cur.onkeydown = function(ev) {
                if( !ev.ctrlKey ) { return; }

                var kc = ev.keyCode, order = info.order;
                var ol = order.length;

                if(kc == 38){ // Up.
                    if(info.on_leave){ info.on_leave(info, cur, i, name); }
                    var k = i - 1;
                    while(list_move(k, name, info, info.limit_u, ev)){ k -= 1; }
                    if(info.on_enter){ info.on_enter(info, cur, k, name); }
                } else if(kc == 40){ // Down.
                    if(!(info.alt_d && info.alt_d(info, cur, i, name, ev))){
                        if(info.on_leave){ info.on_leave(info, cur, i, name); }
                        var k = i + 1;
                        while(list_move(k, name, info, info.limit_d, ev)){ k += 1; }
                        if(info.on_enter){ info.on_enter(info, cur, k, name); }
                    }
                } else if(kc == 37){ // Left.
                    var k = funs.i - 1 + ol;
                    while(list_move(i, order[k%ol], info, info.limit_r, ev)){ k -= 1; }
                } else if(kc == 39){ // Right.
                    var k = funs.i + 1 + ol;
                    while(list_move(i, order[k%ol], info, info.limit_l, ev)){ k += 1; }
                }
            }
            if(info.block_keyup){ cur.onkeyup = function(){} }
            cur.onclick = funs.onclick || cur.onclick;
            cur.hidden = false;
            if(!cur.focus){ alert("Couldnt focus:" + info.nameprep + i + "_" + name); }
            cur.focus();
            return ge('el_' + i).hidden;  // Skip over if whole thing is hidden.
        }
    }
}

ge_prep = "SDmzj9bS6zlWiRoHyaREFQN";
// - js/less_common.js
// Common stuff about finding stuff in elements.

// Finds something with a href.
function find_a_href(el, also, n) {
    n = n || 5
    also = also || {previousSibling:true, nextSibling:true, }
    if( el.href ){ return el.href; }
    if( n > 0 ) {
        for(var i in el.children){
            var href = find_a_href(el.children[i], also, n-1)
            if( href ){ return href; }
        }
    }
    var href;
    if(also.previousSibling){ href = find_a_href(el.previousElementSibling, {}, n-1); }
    if(href){ return href; }
    if(also.nextSibling){ href = find_a_href(el.nextElementSibling, {}, n-1); }
    return href;
}

// Function returning cursor-distance-to-element. Doesnt work. Why
//  arent there clear coordinate systems...
function element_pos_dist(x,y) {
    return function(el) {
        var ex = el.clientLeft - document.body.clientLeft,
            ey = el.clientTop - document.body.clientTop;
        // Note the weights!
//TODO...
        return Math.sqrt(Math.pow(x - ex, 2) + Math.pow(y - ey, 2));
    }
}

function find_closest_els(dist, search_list, range, allow) {
    if( typeof(dist) != 'function' ) { dist = element_pos_dist(dist[0], dist[1]); }
    var ret = [];
    for( var i in search_list ){ // Unsorted, just in-range.
        var el = search_list[i];
        if( el && dist(el) < range && (!allow || allow(el))) { ret.push(el); }
    }
    ret.sort(dist);
    return ret;
}

function replace_all(str, replacers) {
    for( var k in replacers ) {
        var n = str.replace("{%" + k + "}", replacers[k]);
        while( n != str ){
            str = n;
            n = str.replace("{%" + k + "}", replacers[k]);
        }
    }
    return str;
}

function activated_list(into, list, string_fun, alter_fun) {
    var h = "<table>";
    if( typeof(string_fun) == 'function' ) {
        for(var i in list) { h += string_fun(list[i], parseInt(i)); }
    } else {
        for(var i in list) { list[i].i = i; h += replace_all(string_fun, list[i]); }
    }
    into.innerHTML += h + "</table>";

    if(alter_fun) { // NOTE/TODO `list_move` might be better.
        for(var i in list) {  // Mysteriously it turns into a string fucking me up.
            alter_fun(list[i], parseInt(i));
        }
    }
}

// - js/pegasus_send.js
// Send to pegasus, but w/o the pegasus js available.

function pegasus_send(server_url, on_name, data, onload) {
    var path = on_name.split("/")
    var last = path.pop()

    var full_url = server_url + path.join("/") + "/PegasusJs/" + last;
    var send_data = JSON.stringify({d:data});

    GM_xmlhttpRequest({
        method: 'POST',
        url: full_url,
        data: send_data,
        headers: {
            'Content-Type': "application/x-www-form-urlencoded"
        },
        onload: onload
    });
}

// - figure_server.js
var server_url = GM_getValue('server', "http://localhost:9090/");
function send(on_name, data, onload){
    data[0].dumb_pw = GM_getValue('dumb_pw', "{%dumb_pw}");

    var extra = GM_getValue('extra');  // Extra data for doing stuff. And things.
    if(extra){ data[0].extra = extra; }

    pegasus_send(server_url, on_name, data, onload);
}


// - list_assist.js
// Enter a list of actions, defaultly of links.
function produce_action_list(into, list, html, go_action, before_id, after_id) {
    activated_list(into, list,
                   html || ("<!--{%i}--><tr><td><button id='SDmzj9bS6zlWiRoHyaREFQNcmd_vid_{%i}'>" +
                            "{%textContent}</button></td><td>" + 
                            "<a href='{%href}'><code>{%href}</code></a></td></tr>"),
                   function(el, j) {
                       var set = ge('cmd_vid_' + j);
                       set.onclick = function(){ go_action(el, j); }
                       set.onkeydown = function(ev) {
                           if( ev.keyCode == 40 ) {
                               ge((after_id && j == list.length-1) ? after_id :
                                  'cmd_vid_' + (j+1)).focus();
                           } else if( ev.keyCode == 38 ){
                               ge((before_id && j == 0) ? before_id :
                                  ('cmd_vid_' + (j - 1))).focus();
                           }
                       }
                       set.onblur = function(ev) {
                           focus_table_list(set, true);
                       }
                       set.onfocus = function(ev){
                           focus_table_list(set); //cur_sel_list_cleanup);
                       }
                   });
}


var command_element;

function sayit() {
    alert("Submitted:" + command_element.value);
}

var selection, pos_frac;  // Holds selection, as otherwise lost due to focus change.

var iface_state = {}

document.onmouseover = function(ev){
    var is = iface_state;
    is.hovered = ev.target;
    is.hovered_href = is.hovered.href || is.hovered_href;
    is.hovered_src  = is.hovered.src || is.hovered_src;

//    is.x = ev.clientX - document.body.clientLeft;
//	  is.y = ev.clientY - document.body.clientTop;
}

function currentPosFraction()
{
    var el = document.documentElement;

    var w = el.scrollHeight;// - el.clientHeight;
    var h = el.scrollWidth; //  - el.clientWidth;

    var x = el.scrollTop;  //  + d.body.scrollTop;
    var y = el.scrollLeft; // + d.body.scrollLeft;

// TODO better to just pass w,h along?
    return [x/w, y/h]
}

var focus_from;  // Where the focus came from.(hopefully)
below_cmd_input = null;

function toggle_commandpanel(immediate) {
    selection = window.getSelection().toString();
    pos_frac  = currentPosFraction();

    var document = window.document;
    if( command_element ) {  // Already exists, just toggle.
        command_element.hidden = !command_element.hidden;
    } else {
// Doesnt exist yet, make and enable.
        var element = document.createElement('div');
        command_element = element;
        element.id = 'SDmzj9bS6zlWiRoHyaREFQNCommandPanel'

        var h = "";  // TODO damn styles enter it...
// - parts/command_panel.htm
h += "Cmd <input id='SDmzj9bS6zlWiRoHyaREFQNcommand_immediate' type='checkbox'>";
h += "<input id='SDmzj9bS6zlWiRoHyaREFQNcommand_input' onsubmit='sayit();' onkeydown='sayit();'>";
h += "<button onclick='sayit();'>Do</button>";
h += "<span id='SDmzj9bS6zlWiRoHyaREFQNcommand_extend'</span>";

        element.innerHTML = h;

        document.body.appendChild(element);

        // Run stuff if complete inputs.
        ge('command_input').oninput = function(){
            var ci = ge('command_input');
            // Strip out the command starter.
            ci.value = ci.value.replace(";", "");

            if( ge('command_immediate').checked ) {
                var fun = funs[ci.value];
                if(fun && fun()) {
                    ci.value = "";
                    toggle_commandpanel();
                }
            }
        }
        var inp_onkeydown = function(ev) {
            if(below_cmd_input && ev.ctrlKey ){
                var kc = ev.keyCode;
                if( kc == 40 ){ ge(below_cmd_input).focus(); }
            }
        }
        ge('command_input').onkeydown = inp_onkeydown;
    }
    ge('command_immediate').checked = immediate;
    if( command_element.hidden ) {
        ge('command_input').blur();
        if( focus_from ) { focus_from.focus(); focus_from = null; }
    } else {
        focus_from = document.activeElement;
        ge('command_input').focus();
    }
}

function finish_commandpanel() {
    ge('command_extend').innerHTML = ""; // Clean up.
    ge('command_input').value = "";
    toggle_commandpanel(); // Turn off.
}

GM_registerMenuCommand("Command Panel", toggle_commandpanel);

var funs = {};

// - userscripts/cmds_list.js
// - make_bookmark.js
// ---- Bookmarks.

// NOTE strongly suggest not editing,
//  to be superseeded by apps/bookmarks/assets/js/bookmark_setup.js

function make_bookmark() {
    var h = "";
    // - parts/make_bookmark.htm
h += "<span style='font-size:150%; text-weight:bold'>Bookmark</span>";
h += "<table>";
h += "  <tr><td>Uri:</td>  <td><input type='text' id='SDmzj9bS6zlWiRoHyaREFQNcmd_bm_uri'></td></tr>";
h += "  <tr><td>Title:</td><td><input type='text' id='SDmzj9bS6zlWiRoHyaREFQNcmd_bm_title'></td></tr>";
h += "  <tr><td>Text:</td> <td><textarea id='SDmzj9bS6zlWiRoHyaREFQNcmd_bm_text'></textarea></td></tr>";
h += "  <tr><td>Quote:</td><td><textarea id='SDmzj9bS6zlWiRoHyaREFQNcmd_bm_quote'></textarea></td></tr>";
h += "  <!-- TODO tags enter-to-add-1 and make them buttons-to-remove one. -->";
h += "  <tr><td>Tags</td>  <td><input type='text' id='SDmzj9bS6zlWiRoHyaREFQNcmd_bm_tags'>";
h += "      <span id='SDmzj9bS6zlWiRoHyaREFQNcmd_bm_taglist'></span></td></tr>";
h += "  <tr><td span=2><button id='SDmzj9bS6zlWiRoHyaREFQNcmd_bm_submit'>Submit</button></td></tr>";
h += "</table>";

    ge('command_extend').innerHTML = h;
    ge('cmd_bm_uri').value   = document.documentURI;
    ge('cmd_bm_quote').value = selection;

    // NOTE: otherwise need to escape stuff.(which would be silly)
    ge('cmd_bm_title').value = document.title;

    below_cmd_input = 'cmd_bm_uri';
    var graph = {
        //command_input : { d :'cmd_bm_uri' },
        cmd_bm_uri    : { d :'cmd_bm_title', u : 'command_input' },
        cmd_bm_title  : { d :'cmd_bm_text',  u : 'cmd_bm_uri' },
        cmd_bm_text   : { d :'cmd_bm_quote', u : 'cmd_bm_title' },
        cmd_bm_quote  : { d :'cmd_bm_tags',  u : 'cmd_bm_text' },
        cmd_bm_tags   : {
            d : 'cmd_bm_submit', u:'cmd_bm_quote',
            r : function(){
                var to = ge('cmd_bm_taglist').childNodes[0];
                if(to){ to.focus(); }
            },
            l : function(){
                var children = ge('cmd_bm_taglist').childNodes;
                var to = children[children.length - 1];
                if(to){ to.focus(); }
            }
        },
        cmd_bm_submit : { u : 'cmd_bm_tags' }
    };
    var fg = follow_graph(graph);

    ge('cmd_bm_uri').onkeydown = fg;
    ge('cmd_bm_title').onkeydown = fg;
    var config = { max_rows:20, cols:90 }
    textarea_update('cmd_bm_text',  fg, config);
    textarea_update('cmd_bm_quote', fg, config);

    var cs = ge('cmd_bm_submit');
    cs.onclick = function() {
        var tag_els = ge('cmd_bm_taglist').childNodes;
        var tag_list = [];
        for(var i in tag_els){
            if( tag_els[i].nodeName == 'BUTTON' ){
                tag_list.push(tag_els[i].textContent);
            }
        }
        send('bookmarks/.collect',
             [{},
              ge('cmd_bm_uri').value,
              ge('cmd_bm_title').value,
              ge('cmd_bm_text').value,
              ge('cmd_bm_quote').value,
              tag_list, pos_frac]);

        // TODO instead of returning, respond by telling if success?
        finish_commandpanel();
    }

    cs.onkeydown = function(ev) {  // Cycle _inside_ the thing.
        if( ev.keyCode == 9 ){ ge('command_immediate').focus(); }
        else{ fg(ev); }
        // else if( ev.keyCode == 13 ){ cs.onclick(); }  // Already automatically so.
    }

    var ct = ge('cmd_bm_tags');
    ct.onkeydown = function(ev){
        if( ev.keyCode == 13 ) {
            // TODO shift-enter should focus-and-submit, otherwise,
            //  just select the button-to-submit.(currently not so..)
            if( ct.value.length == 0 ){ cs.focus(); return false; }

            // Add a button signifying the tag, clicking removes.
            var button = document.createElement('button');
            button.textContent = ct.value;
            button.onmouseover = function(){  // TODO use CSS hover instead..
                button.style['text-decoration'] = 'line-through';
            }
            button.onmouseout = function(){ button.style['text-decoration'] = null }

            button.onclick = function(){
                var to = button.nextSibling || button.previousSibling;
                if(to){ to.focus(); } else{ ge('cmd_bm_tags').focus(); }
                ge('cmd_bm_taglist').removeChild(button);
            };

            button.onkeydown = function(ev) {
                if( ev.keyCode == 37 ) {
                    (button.previousSibling || ge('cmd_bm_tags')).focus();
                } else if( ev.keyCode == 39 ) {
                    (button.nextSibling || ge('cmd_bm_tags')).focus();
                } else if( ev.keyCode == 40 ) {
                    ge('cmd_bm_submit').focus();
                } else if( ev.keyCode == 38 ) {
                    ge('cmd_bm_quote').focus();
                }
            }

            // We'll just use this as list of tags too.
            ge('cmd_bm_taglist').appendChild(button);
            ct.value = "";
        }
        fg(ev);
    }

    ge('cmd_bm_text').focus();
}

funs.bm = make_bookmark;

default_value("qm.enabled", "true")
if(GM_getValue("qm.enabled")) {
    // - quickmarks.js
// --- Quick bookmarks (not good enough!)

default_value('qm.linklist', 'true');

var cmd_make_quickmark_fun = function(el) {
    //TODO
    send('bookmarks/.make_quickmark',
         [{}, el.href, document.title, ge('cmd_qm_name').value, pos_frac],
         function(){ finish_commandpanel(); });
}

function cmd_make_quickmark() {  // Try open as video.
    ge('command_extend').innerHTML = "working...";

    var hover_uri = iface_state.hovered_href;
    var hover_src = iface_state.hovered_src;
    if( GM_getValue('qm.linklist') == "true" ) {
        // Get sorted list.
        var list = [{ textContent:"cur page", href:document.documentURI }];
        if(hover_uri){ list.unshift({ textContent:"hovered", href:hover_uri }); }
        if(hover_src){ list.push({ textContent:"img src", href:hover_src }); }

        ge('command_extend').innerHTML = "<input id='SDmzj9bS6zlWiRoHyaREFQNcmd_qm_name' value='default'>";
        produce_action_list(ge('command_extend'), list, null, cmd_make_quickmark_fun,
                            'cmd_qm_name');

        ge('cmd_qm_name').onkeydown = function(ev) {
            if( ev.keyCode == 40 ) {
                ge('cmd_vid_0').focus();
            } else if(ev.keyCode == 38) {
                ge('command_input').focus();
            } else if( ev.keyCode == 13 ) {
                // Enter uses the top one.(hovered or current page)
                cmd_bookmark_fun(list[0]);
            }
        }

        ge('command_input').onkeydown = function(ev) {
            if(ev.keyCode == 40){ ge('cmd_vid_0').focus(); }
        }
        ge('cmd_qm_name').focus();
    } else {
        cmd_make_quickmark_fun({href:hover_uri || hover_src || document.documentURI});
    }
}

var quickmark_prev_name;
var cmd_go_quickmark_fun = function(name) {
    if( quickmark_prev_name != name && name != "" ) {  // Only if changed.
        quickmark_prev_name = name;
        ge('cmd_qm_list').innerHTML = "getting...";
        send('bookmarks/.get_quickmarks_html', [{}, name],
             function(result_obj) {
                 var html_list = JSON.parse(result_obj.responseText)[0];
                 ge('cmd_qm_list_cnt').innerHTML = html_list.length;
                 var h = "";
                 for(var i in html_list) { h += html_list[i]; }
                 ge('cmd_qm_list').innerHTML = h;
             });
    }
}
// TODO this thing doesnt have the needed classes.
//
// TODO can be improved; button to "open all in tabs",
// selecting a subset, "open selected in tabs", deleting.
//
// HOWEVER, consider what you want in the list functionality in general,
// preferably it transfers to _both_
function cmd_go_quickmark() {
    var h = "Name <input id='SDmzj9bS6zlWiRoHyaREFQNcmd_qm_name' value='default'>";
    h += "Got <span id='SDmzj9bS6zlWiRoHyaREFQNcmd_qm_list_cnt'>(count)</span>";
    h += "<table id='SDmzj9bS6zlWiRoHyaREFQNcmd_qm_list'><tr><td colspan=4>(initial)</td></tr></table>";
    ge('command_extend').innerHTML = h;

    var name_el = ge('cmd_qm_name');
    name_el.focus();

    var d = function() {
        list_move(1, 'linked_title', {
            limit_u:function() { ge('cmd_qm_name').focus(); },
            nameprep:"list_el_",
            mirror:{i:0}, linked_title:{i:1},
            order:["mirror", "linked_title"],
        });
    }

    var graph = { //command_input:{ r:'cmd_qm_name',   d:'cmd_qm_name' },
                  cmd_qm_name : { l:'command_input', u:'command_input',
                                  d:d
                                }
                };
    below_cmd_input = 'cmd_qm_name';
    var fg = follow_graph(graph);
    name_el.onkeydown = fg;

    quickmark_prev_name = null;  // Force re-do.
    cmd_go_quickmark_fun(name_el.value); // Default.
    name_el.onkeyup = function(ev) {
        cmd_go_quickmark_fun(name_el.value);
    }
}
 // TODO
    funs.qm = cmd_make_quickmark;
    funs.gqm = cmd_go_quickmark;
}

// - cmd_on_string.js
default_value('on_string.width', "80")

function cmd_on_string(fun, button_str, dont_finish) {
    return function() {
        ge('command_extend').innerHTML = "<br><textarea id='SDmzj9bS6zlWiRoHyaREFQNcmd_js_code'></textarea>" +
            "<br><button id='SDmzj9bS6zlWiRoHyaREFQNcmd_submit'>" + button_str + "</button>";

        var graph = {
            //command_input : { d:'cmd_js_code' },
            cmd_js_code   : { u:'command_input', d:'cmd_submit'},
            cmd_submit    : { u:'cmd_js_code' }
        }
        var fg = follow_graph(graph);

        below_cmd_input = 'cmd_js_code';

        var code_el = ge('cmd_js_code');

        code_el.rows = Math.max(code_el.value.split("\n").length, 0);
        code_el.cols = Number(GM_getValue('on_string.width'));

        var cs = ge('cmd_submit');

        cs.onclick = function() {
            fun(code_el.value);
            if(!dont_finish){ finish_commandpanel(); }
        }
        cs.onkeydown = fg;

        code_el.onkeydown = function(ev) {
            code_el.rows = Math.max(code_el.value.split("\n").length, 0);

            if( ev.keyCode == 13 && ev.shiftKey ) { cs.onclick(); }
            fg(ev);
        }
        code_el.focus();
    }
}


default_value('js.enabled', 'false');
// --- Javascript/lua evaluation.
if( GM_getValue('js.enabled') == 'true' ) {
    funs.js  = cmd_on_string(function(str){ alert(eval(str)) }, "Run js");
}

default_value('lua.enabled', 'false');
// NOTE: doesnt work at this point!
if( GM_getValue('lua.enabled', false) ) {
    funs.lua = cmd_on_string(function(str){
        send('util/.run_lua', [{}, str], function(result_obj) {
            var result = JSON.decode(result_obj.responseText);
            if(result.disallowed) { alert("Disallowed"); }
            else{ alert("Allowed: " + result); }
            finish_commandpanel();
        });
    }, "Run lua(server side, if allowed)", true);
}

// - cmd_syms.js
default_value("syms.enabled", "true")

if( GM_getValue('syms.enabled') == "true" ) {
    funs.syms = function() {
        var h = "<br><input id='SDmzj9bS6zlWiRoHyaREFQNcmd_sym_val'>"
        h += "<br><span id='SDmzj9bS6zlWiRoHyaREFQNcmd_sym_output'></span>";
        ge('command_extend').innerHTML = h;

        below_cmd_input = 'cmd_sym_val';
        var sym_val = ge('cmd_sym_val');
        sym_val.focus();
        sym_val.onkeydown = function(ev) {
            var kc = ev.keyCode;
            if( kc == 13 ) {
                GM_setClipboard(ge('cmd_sym_output').innerHTML);
                finish_commandpanel();
            } else if( kc == 38 && ev.ctrlKey ){
                ge('command_input').focus();
            }
        }
        sym_val.onkeyup = function(ev) {
            ge('cmd_sym_output').innerHTML = "&" + sym_val.value + ";";
        }
    }
}


// --- Manuals and documentation.
function cmd_opentab(button_str, httpreq) {
    return cmd_on_string(function(str) {
        ge('command_extend').innerHTML +=
            "Working... <code class='minor'>(" + str + ")</code>";
        send(httpreq, [{}, str], function(result_obj){
            var result = JSON.parse(result_obj.responseText);
            if( result.length > 0 ){ GM_openInTab(result); }
            finish_commandpanel();
        });
    }, button_str, true);
}

funs.man   = cmd_opentab("View man page",      'util/.man');
funs.doc   = cmd_opentab("View documentation", 'util/.doc');
funs.pydoc = cmd_opentab("View pydoc page",    'util/.pydoc');

// - cmd_vid.js
default_value('vid.linklist', 'true')
default_value('vid.new_tab', 'true')

// --- Running videos

var cmd_vid_fun = function(el) {
    ge('cmd_vid_say').innerHTML =
        "working...<code class='minor'>(" + el.href + ")</code>";
    send('util/.vid', [{}, el.href],
         function(result_obj) {
             var tab = JSON.parse(result_obj.responseText);
             if( tab ) {
                 var on_get_success = function(){
                     var uri = tab.pref_uri || tab.m_uri;
                     if(GM_getValue('vid.new_tab') == "true" && uri != document.documentURI){
                         GM_openInTab(uri);
                     }
                 }

                 if(tab.get_it) { // Get result asking to get it via the userscript.
                     GM_xmlhttpRequest({
                         method:'GET', url:el.href,
                         onload:function(result_obj){
                             if( tab.view_it ) {
                                 send('history/.collect.mirror',
                                      [{}, el.href, result_obj.responseText],
                                      tab.view_it && on_get_success);
                             }
                         }})
                 } else{ if( tab.view_it ) {  // Asking to view it.
                     on_get_success();
                 } }
             }
             finish_commandpanel();
        });
}

function cmd_vid() {  // Try open as video.
    ge('command_extend').textContent = "working...";

    var hover_uri = iface_state.hovered_href;
    var hover_src = iface_state.hovered_src;
    if( GM_getValue('vid.linklist') == "true" ) {
        // Get sorted list.  (closest links aren't good enough..)
        var list = [{ textContent:"cur page", href:document.documentURI }];
        if(hover_uri){ list.unshift({ textContent:"hovered", href:hover_uri }); }
        if(hover_src){ list.push({ textContent:"img src", href:hover_src }); }

        ge('command_extend').innerHTML =
            "<span id='SDmzj9bS6zlWiRoHyaREFQNcmd_vid_say'></span><span id='SDmzj9bS6zlWiRoHyaREFQNcmd_vid_extend'></span>";
        produce_action_list(ge('cmd_vid_extend'), list, null,
                            cmd_vid_fun, 'command_input');

        below_cmd_input = 'cmd_vid_0';
        ge('cmd_vid_0').focus();
    } else {
        cmd_vid_fun({href:hover_uri || hover_src || document.documentURI});
    }
}

funs.vid = cmd_vid;

// - cmd_mirror.js
// TODO make it a mirror thing.

default_value('mirror.new_tab', "true");
default_value('mirror.list', "true");

var cmd_mirror_fun = function(el) {
    ge('cmd_mirror_say').innerHTML =
        "working...<code class='minor'>(" + el.href + ")</code>";
    send('util/.mirror', [{}, el.href],
         function(result_obj) {
             var tab = JSON.parse(result_obj.responseText);
             if( tab && tab.view_it ) {
                 var uri = tab.pref_uri || tab.m_uri;
                 if(GM_getValue('mirror.new_tab')=="true" && uri != document.documentURI){
                     GM_openInTab(uri);
                 }
             }
             finish_commandpanel();
        });
}

function cmd_mirror() {
    ge('command_extend').textContent = "working...";

    var hover_uri = iface_state.hovered_href;
    var hover_src = iface_state.hovered_src;
    if( GM_getValue('mirror.list') == "true" ) {
        // Get sorted list.  (closest links aren't good enough..)
        var list = [];
        list.unshift({ textContent:"cur page", href:document.documentURI });
        if(hover_uri){ list.unshift({ textContent:"hovered", href:hover_uri }); }
        if(hover_src){ list.push({ textContent:"img src", href:hover_src }); }

        ge('command_extend').innerHTML =
            "<span id='SDmzj9bS6zlWiRoHyaREFQNcmd_mirror_say'></span><span id='SDmzj9bS6zlWiRoHyaREFQNcmd_mirror_extend'></span>";
        produce_action_list(ge('cmd_mirror_extend'), list, null,
                            cmd_mirror_fun, 'command_input');

        below_cmd_input = 'cmd_vid_0';
        ge('cmd_vid_0').focus();
    } else {
        cmd_mirror_fun({href:hover_uri || hover_src || document.documentURI});
    }
}

funs.mirror = cmd_mirror;

function cmd_fclip() {  // TODO cliboardData doesn't work?
    ge('command_extend').innerHTML = "Working...";
    send('util/.fclip', [{}], function(result_obj){
        GM_setClipboard(JSON.decode(result_obj.responseText));
        finish_commandpanel();
    })
}
funs.fclip = cmd_fclip;

// - cmd_values.js

function values_figure_table(search) {
    var str = "";
    for each (var key in GM_listValues()) {
        if( key.search(search) >= 0 ) {
            var val = GM_getValue(key);
            str +=  "<tr><td>" + key + "</td><td>" + val + "</td></tr>";
        }
    }
    return str;
}

function values_act() {
    var key = ge('list_search').value, val = ge('values_set').value;
    if( key == "" ){ return; }
    else if( val == "" ){
        GM_deleteValue(key);
    } else {
        GM_setValue(key, val);
    }
    // Update the list.
    ge('values_list_table').innerHTML = values_figure_table(ge('list_search').value);
}

function cmd_values() {
    var str = '<input id="SDmzj9bS6zlWiRoHyaREFQNlist_search">'
    str += '<input id="SDmzj9bS6zlWiRoHyaREFQNvalues_set">'
    str += '<button id="SDmzj9bS6zlWiRoHyaREFQNvalues_button">Delete&larr;write to set</button>';
    str += '<table id="SDmzj9bS6zlWiRoHyaREFQNvalues_list_table">'
    str += values_figure_table("") + '</table>';
    ge('command_extend').innerHTML = str;

    below_cmd_input = 'list_search';
    var search_keyup = function(ev){
        ge('values_list_table').innerHTML = values_figure_table(ge('list_search').value);
        if( ev.ctrlKey ){
            var kc = ev.keyCode;
            if( kc == 38 || kc == 37 ){ ge('command_input').focus(); }
            else if( kc == 40 || kc == 13 ||  kc == 39 ){
                ge('values_set').focus();
            }
        }
    }
    ge('list_search').onkeyup = search_keyup;
    ge('list_search').focus();

    var set_keyup = function(ev){
        ge('values_button').textContent =
            (ge('values_set').value.length > 0 ? "Set" : "Delete");
        var kc = ev.keyCode;
        if( kc == 13 ){ values_act(); }
        else if( ev.ctrlKey && (kc == 38 || kc == 37) ){ ge('list_search').focus(); }
        else if( ev.ctrlKey && (kc == 40 || kc == 39) ){ ge('values_button').focus(); }
    }
    ge('values_set').onkeyup = set_keyup;

    var button_keyup = function(ev) {
        var kc = ev.keyCode;
        if(ev.ctrlKey && (kc == 38 || kc == 37) ){ ge('values_set').focus(); }
    }
    ge('values_button').onkeyup = button_keyup;
    ge('values_button').onclick = values_act;
}

funs.values = cmd_values;


// Keydown listener.

(window.opera ? document.body : document).addEventListener('keydown', function(ev) {
    iface_state.x = ev.pageX;
    iface_state.y = ev.pageY;
    if( ev.ctrlKey && ev.keyCode == 59 ) { // Thats control-;.
        toggle_commandpanel(!ev.shiftKey);
    } else if( command_element && !command_element.hidden ){
        if( ev.keyCode == 27 ) { // Escape.
            ge('command_input').value = "";
            toggle_commandpanel();
            return;
        }
    }
    return false;
}, !window.opera);

